##########################################################################################
################################## SOFTWARE R - CAST 6 ###################################
##########################################################################################

# Nastaveni pracovniho adresare - napr.:
setwd("c:/Users/janousova/Documents/Vyuka/DSAN01 - Analyza dat pro neurovedy/2013 jaro/Materialy/Rko")



############################# Analyza preziti #############################

### nacteni dat:
prez <- read.table(file = "data_preziti.txt", sep = "\t", dec = ".", header = TRUE)

### pocet pacientu:
nrow(prez)

### pocet zemrelych:
sum(prez$umrti==1)

### Kaplan-Meieruv (K-M) odhad pro celkove preziti (definovano predem jako datum posledniho sledovani/umrti - datum dg):
# cas: cas od data dg do data posledniho sledovani/umrti 
# umrti: 1..zemreli pacienti, 0..cenzorovani pacienti
library(survival) # nacteni knihovny "survival"
km.surv <- survfit(Surv(cas, umrti) ~ 1, data = prez) # vypocet K-M odhadu
plot(km.surv, xlab="Mesice", ylab="Podil zijicich pacientu") # vykresleni K-M krivky preziti
summary(km.surv) # vypis jednotlivych casu udalosti a poctu udalosti

### K-M krivka pro vice skupin pacientu - celkove preziti (dle K-M) pro zeny a muze:
km.pohlavi <- survfit(Surv(cas, umrti) ~ pohlavi, data = prez) # pohlavi: 1..zeny, 2..muzi
plot(km.pohlavi[pohlavi=1]) # vykresleni krivky preziti pro zeny
plot(km.pohlavi[pohlavi=2]) # vykresleni krivky preziti pro muze
plot(km.pohlavi) # vykresleni obou krivek preziti do 1 grafu (krivky jsou bez intervalu spolehlivosti)

# vykresleni obou krivek preziti do 1 grafu i s intervaly spolehlivosti:
plot(km.pohlavi[pohlavi=1])
lines(km.pohlavi[pohlavi=2]$time, km.pohlavi[pohlavi=2]$surv, type="s", col=2)
lines(km.pohlavi[pohlavi=2]$time, km.pohlavi[pohlavi=2]$lower, type="s", col=2, lty=2)
lines(km.pohlavi[pohlavi=2]$time, km.pohlavi[pohlavi=2]$upper, type="s", col=2, lty=2)

# logrank test pro rozdil v preziti:
km.pohlavi.test <- survdiff(Surv(cas, umrti) ~ pohlavi, data = prez)
km.pohlavi.test

